--Pop ver. 1.5 programmed by veethree(v3p)
function love.load()
	math.randomseed(os.time())
	--IMAGES
	sb = love.graphics.newImage("image/soundb.png")
	sbm = love.graphics.newImage("image/soundbm.png")
	shadow = love.graphics.newImage("image/soundbs.png")	
	fade = love.graphics.newImage("image/vig.png")
	sidebar = love.graphics.newImage("image/sidebar.png")
	dot = love.graphics.newImage("image/dot.png")
	star = love.graphics.newImage("image/star.png")
	goldstar = love.graphics.newImage("image/goldstar.png")
	--MENU
	menubg = love.graphics.newImage("image/menu_bg.png")
	lostbg = love.graphics.newImage("image/lost_bg.png")
	pausebg = love.graphics.newImage("image/pause_bg.png")
	--START BUTTON
	startb = love.graphics.newImage("image/b_start.png")
	startbC = love.graphics.newImage("image/b_startC.png")
	starthover = false
	startX = 750/2-(188/2)
	startY = 400/2-(64/2)
	--OPTIONS BUTTON	
	optionsb = love.graphics.newImage("image/b_options.png")
	optionsbC = love.graphics.newImage("image/b_optionsC.png")
	optionshover = false
	optionsX = 750/2 -(132/2)
	optionsY = 245
	--EXIT BUTTON
	exitb = love.graphics.newImage("image/b_exit.png")
	exitbC = love.graphics.newImage("image/b_exitC.png")
	exithover = false
	exitY = 302
	--RESTART BUTTON
	restartb = love.graphics.newImage("image/b_restart.png")
	restartbC = love.graphics.newImage("image/b_restartC.png")
	--Main menu button
	menub = love.graphics.newImage("image/b_menu.png")
	menubC = love.graphics.newImage("image/b_menuC.png")
	--Resume button
	resumeb = love.graphics.newImage("image/b_resume.png")
	resumebC = love.graphics.newImage("image/b_resumeC.png")

	--SOUND
	pop = love.audio.newSource("sound/pop.ogg", "static")
	pop2 = love.audio.newSource("sound/pop2.ogg", "static")
	pop3 = love.audio.newSource("sound/pop3.ogg", "static")
	pop:setVolume(0.5)
	pop2:setVolume(0.5)
	pop3:setVolume(0.5)
	
	--Game Variables
	x = math.random(150, 750 - 20)
	y = math.random(150, 400 - 20)
	r = 0
	dtype = 0 --0 = dot, 1 = star, 2 = gold star
	typernd = math.random(0, 20)
	score = 12
	timelasted = 0
	itime = 15 -- Initial Time
	timeleft  = itime
	gamestate = "menu" --menu, game, lost, paused, 
	
	-- Misc
	love.graphics.setBackgroundColor(math.random(50, 200), math.random(50, 200), math.random(50, 200))
	f = love.graphics.newFont(18)
	bigf = love.graphics.newFont(30)
	love.graphics.setFont(f)
	
	--Particle Systems
	part = love.graphics.newImage("image/part.png")
	p = love.graphics.newParticleSystem(part, 40000)
	p:setEmissionRate(3)
	p:setParticleLife(5)
	p:setSpread(10)
	p:setSize(0.5)
	p:setSizeVariation(1)
	p:setPosition(500,200)
	p:setSpeed(10)
	p:setColor(255, 255, 255, 50, 255, 255, 255, 0)
	p:start()
	
	love.graphics.setBlendMode("alpha")
end

function love.update(dt)
	--Timer
	mx = love.mouse.getX()
	my = love.mouse.getY()
	if gamestate == "game" then
		r = r + dt
		p:setPosition(love.mouse.getPosition())
		p:update(dt)
		timeleft = timeleft - dt
		timelasted = timelasted + dt
		if timeleft <= 0 then
			gamestate = "lost"
			timeleft = itime
		end
	elseif gamestate == "menu" then
		--start hover check
		if mx > startX and mx < startX + 188 and my > startY and my < startY + 64 then
			starthover = true
		else
			starthover = false
		end
		--options hover check
		if mx > optionsX and mx < optionsX + 132 and my > optionsY and my < optionsY + 46 then
			optionshover = true
		else
			optionshover = false
		end
		--exit hover check
		if mx > optionsX and mx < optionsX + 132 and my > exitY and my < exitY + 46 then
			exithover = true
		else
			exithover = false
		end
	elseif gamestate == "lost" then
		--restart hover check
		if mx > startX and mx < startX + 188 and my > startY and my < startY + 64 then
			starthover = true
		else
			starthover = false
		end
		--Menu hover check
		if mx > optionsX and mx < optionsX + 132 and my > optionsY and my < optionsY + 46 then
			optionshover = true
		else
			optionshover = false
		end
	elseif gamestate == "paused" then
		--resume hover check
		if mx > startX and mx < startX + 188 and my > startY and my < startY + 64 then
			starthover = true
		else
			starthover = false
		end
		--Menu hover check
		if mx > optionsX and mx < optionsX + 132 and my > optionsY and my < optionsY + 46 then
			optionshover = true
		else
			optionshover = false
		end
	end
end

function love.draw() --================DRAW
	if gamestate == "menu" then
		love.graphics.draw(menubg)
		--START
		if starthover == false then
			love.graphics.draw(startb, startX, startY)
		elseif starthover == true then
			love.graphics.draw(startbC, startX, startY)
		end
		--OPTIONS
		if optionshover == false then
			love.graphics.draw(optionsb, optionsX, optionsY)
		elseif optionshover == true then
			love.graphics.draw(optionsbC, optionsX, optionsY)
		end
		--EXIT
		if exithover == false then
			love.graphics.draw(exitb, optionsX, exitY)
		elseif exithover == true then
			love.graphics.draw(exitbC, optionsX, exitY)
		end
	elseif gamestate == "game" then
		--HUD
		love.graphics.setBlendMode("additive")
		love.graphics.draw(p)
		love.graphics.setBlendMode("alpha")
		love.graphics.draw(fade, 150, 0)
		love.graphics.draw(sidebar)
		love.graphics.print("Score: "..score, 5, 5)
		love.graphics.print("Time: "..math.floor(timeleft), 5, 25)
		--Game Elements
		if dtype == 0 then
			love.graphics.draw(dot, x, y)
		elseif dtype == 1 then
			love.graphics.draw(star, x + 10, y + 10, r, 1, 1, 10, 10)
		elseif dtype == 2 then
			love.graphics.draw(goldstar, x + 10, y + 10, r, 1, 1, 10, 10)
		end
	elseif gamestate == "lost" then
		love.graphics.draw(lostbg)
		love.graphics.setFont(bigf)
		love.graphics.print("Game Over", 750/2-80, 10)
		love.graphics.setFont(f)
		love.graphics.print("You lasted "..math.floor(timelasted).." seconds and scored "..score.." points!", 180, 140)
		--RESTART button
		if starthover == false then
			love.graphics.draw(restartb, startX, startY)
		elseif starthover == true then
			love.graphics.draw(restartbC, startX, startY)
		end
		--MENU button
		if optionshover == false then
			love.graphics.draw(menub, optionsX, optionsY)
		elseif optionshover == true	then
			love.graphics.draw(menubC, optionsX, optionsY)
		end
	elseif gamestate == "paused" then
		love.graphics.setBlendMode("additive")
		love.graphics.draw(p)
		love.graphics.setBlendMode("alpha")
		love.graphics.draw(sidebar)
		love.graphics.draw(fade, 150, 0)
		love.graphics.print("Score: "..score, 5, 5)
		love.graphics.print("Time: "..math.floor(timeleft), 5, 25)
		if dtype == 0 then
			love.graphics.draw(dot, x, y)
		elseif dtype == 1 then
			love.graphics.draw(star, x + 10, y + 10, r, 1, 1, 10, 10)
		elseif dtype == 2 then
			love.graphics.draw(goldstar, x + 10, y + 10, r, 1, 1, 10, 10)
		end
		love.graphics.draw(pausebg)
		--RESUME button
		if starthover == false then
			love.graphics.draw(resumeb, startX, startY)
		elseif starthover == true then
			love.graphics.draw(resumebC, startX, startY)
		end
		--MENU button
		if optionshover == false then
			love.graphics.draw(menub, optionsX, optionsY)
		elseif optionshover == true	then
			love.graphics.draw(menubC, optionsX, optionsY)
		end
		love.graphics.setFont(bigf)
		love.graphics.print("Paused!", 750/2 - 65 , 20)
		love.graphics.setFont(f)
	end
end

function love.mousepressed(mx, my, key)
	if key == "l" then
		if gamestate == "menu" then -- MAIN MENU BUTTON CLICKS
			if starthover == true then -- start
				gamestate = "game"
			elseif exithover == true then -- exit
				love.event.push('q')
			end
		elseif gamestate == "paused" then
			if starthover == true then --resume
				gamestate = "game"
			elseif optionshover == true then -- menu
				gamestate = "menu"
				timeleft = itime
				score = 0
				timelasted = 0
			end
		elseif gamestate == "lost" then -- LOST MENU BUTTON CLICKS
			if starthover == true then --restart
				gamestate = "game"
				score = 0
				timeleft = itime
				timelasted = 0
				x = math.random(150, 750 - 20)
				y = math.random(150, 400 - 20)
			elseif optionshover == true then -- menu
				gamestate = "menu"
				timeleft = itime
				score = 0
				timelasted = 0
				x = math.random(150, 750 - 20)
				y = math.random(150, 400 - 20)
			end
		end
		if gamestate == "game" then
			if mx > x and mx < x + 20 and my > y and my < y + 20 then -- DOT CLICKED CALLBACK
				--Sound
				i = math.random(0,2)
				if dtype == 0 then
					if i == 0 then
						pop:setPitch(1.0)
					elseif i == 1 then
						pop:setPitch(0.9)
					elseif i == 2 then
						pop:setPitch(1.1)
					end
					love.audio.play(pop)
				elseif dtype == 1 then
					if i == 0 then
						pop2:setPitch(1.0)
					elseif i == 1 then
						pop2:setPitch(0.9)
					elseif i == 2 then
						pop2:setPitch(1.1)
					end
					love.audio.play(pop2)
				elseif dtype == 2 then
					if i == 0 then
						pop3:setPitch(1.0)
					elseif i == 1 then
						pop3:setPitch(0.9)
					elseif i == 2 then
						pop3:setPitch(1.1)
					end
					love.audio.play(pop3)
				end
				--Type
				typernd = math.random(0, 20)
				if typernd <= 20 and typernd >= 3 then -- dot
					dtype = 0
				elseif typernd <= 2	and typernd >= 1 then -- star
					dtype = 1
				elseif typernd == 0 then -- gold star
					dtype = 2
				end
				--Score		
				if dtype == 0 then -- Dot
					score = score + 1
				elseif dtype == 1 then -- Star
					score = score + 2
					timeleft = timeleft + 5
				elseif dtype == 2 then -- Gold Star
					score = score + 5
					timeleft = timeleft + 10
				end
				x = math.random(150, 750 - 20)
				y = math.random(150, 400 - 20)
				love.graphics.setBackgroundColor(math.random(50, 200), math.random(50, 200), math.random(50, 200))
			end
		end
	end
end

function love.keypressed(key)
	if key == "p" then
		if gamestate == "game" then
			gamestate = "paused"
		end
	end
end